%%% Code to replicate the graphs in the paper
%%% Neil J. MacKinnon and and Jesse Hoey Operationalizing the Relation Between Affect and Cognition With the Somatic Transform. Emotion Review, 2021
%%% 
%% sentiment dimension to plot
%% 1=Evaluation, 2=Power, 3=Activity
dimtoplot=2;




%% load up the identities you want here - I am doing 4 of them. See the HOWTO for how to generate these XYZ.txt files - they are simply the data points
% the plots from the paper are generated using his:
idstoplot={'Doctor','Nurse','Patient'};
%% other plots that you get as a bonus
idstoplot={'Doctor','Nurse','Patient','Intern'};
%% how many is here
maxi=size(idstoplot,2);
%NOTE: I am do ZERO error checking here. If your .txt files don't match then you have to regenerate them.



klstyles={};
klcolors={};
for i=1:4:maxi
  %% use this one to plot dashed/dotted as well as color
  klstyles=[klstyles,'-','--',':','-.'];
  klcolors=[klcolors,'r','g','b','k'];
  %% this one plots all solid
 %% klstyles=[klstyles,'-','-','-','-'];
end



%% other things that can be modified 
binstoplot=20;
y=[-4.3:0.1:4.3];



x=load("doctor.txt");
vard=var(x(:,dimtoplot));
meany=mean(x(:,dimtoplot));

pydoctor=((1/sqrt(2*pi*vard))*exp(-0.5*((y-meany).^2)/vard));

x=load("nurse.txt");
vard=var(x(:,dimtoplot));
meany=mean(x(:,dimtoplot));

pynurse=((1/sqrt(2*pi*vard))*exp(-0.5*((y-meany).^2)/vard));


x=load("patient.txt");
vard=var(x(:,dimtoplot));
meany=mean(x(:,dimtoplot));

pypatient=((1/sqrt(2*pi*vard))*exp(-0.5*((y-meany).^2)/vard));


x=load("intern.txt");
vard=var(x(:,dimtoplot));
meany=mean(x(:,dimtoplot));

pyintern=((1/sqrt(2*pi*vard))*exp(-0.5*((y-meany).^2)/vard));

py=[pydoctor;pynurse;pypatient;pyintern];

px=[0.45,0.2,0.01,0.34];

pytotal=px*py;

%% now plot as a function of y for different values of mean of the prior over y, uy
figure(1);
clf;
plot(y',py(1,:)',klstyles{1},'Color',klcolors{1},'LineWidth',3);
hold on;
plot(y',py(2,:)',klstyles{2},'Color',klcolors{2},'LineWidth',3);
plot(y',py(3,:)',klstyles{3},'Color',klcolors{3},'LineWidth',3);
if (maxi==4)
  plot(y',py(4,:)',klstyles{4},'Color',klcolors{4},'LineWidth',3);
end
set(gca,'FontWeight', 'bold');
legend(idstoplot);
ylabel('P({\it y}|{\it x})','FontSize',12,'FontWeight','bold');
xlabel('{\it y} = power','FontSize',12,'FontWeight','bold');
print('figure1.pdf','-dpdf');
print('figure1.png','-dpng');


pyn=py(1:maxi,:)./sum(py(1:maxi,:));
%% now plot as cumulative distributions
figure(2)
clf;				%plot(y',pyn','LineWidth',3);
plot(y',pyn(1,:)',klstyles{1},'Color',klcolors{1},'LineWidth',3);
hold on
plot(y',pyn(2,:)',klstyles{2},'Color',klcolors{2},'LineWidth',3);
plot(y',pyn(3,:)',klstyles{3},'Color',klcolors{3},'LineWidth',3);
if maxi==4
  plot(y',py(4,:)',klstyles{4},'Color',klcolors{4},'LineWidth',3);
end
set(gca,'FontWeight', 'bold');
legend(idstoplot,'Location','NorthWest');
ylabel('P({\it x})','FontSize',12,'FontWeight','bold');
xlabel('{\it y} = power','FontSize',12,'FontWeight','bold');
print('figure2.pdf','-dpdf');
print('figure2.png','-dpng');

pytn=pytotal; %./sum(pytotal);
%% now plot the sum  -- this is not in the paper
figure(3)
clf;
plot(y',pytn','LineWidth',3);
legend("sum given px (see figure 4)",'Location','NorthWest');
set(gca,'FontWeight', 'bold');
ylabel('P(y)','FontSize',12,'FontWeight','bold');
xlabel('y=power','FontSize',12,'FontWeight','bold');
print('figure3.pdf','-dpdf');
print('figure1b.png','-dpng');


%% the denotative values that were used to generate figure 4
figure(4)
clf;
bar(px)
set(gca,'FontWeight', 'bold');
set(gca,'XTickLabel',idstoplot);
ylabel('P(x)','FontSize',12,'FontWeight','bold');
print('figure4.pdf','-dpdf');
print('figure1c.png','-dpng');
